Cookie (Servlet 6.0 API Documentation - Apache Tomcat 10.1.20)
Description: declaration: package: jakarta.servlet.http, class: Cookie

Package jakarta.servlet.http

# Class Cookie

java.lang.Object
jakarta.servlet.http.Cookie

All Implemented Interfaces:
  `Serializable`, `Cloneable`

public class Cookie extends Object implements Cloneable, Serializable
Creates a cookie, a small amount of information sent by a servlet to a Web browser, saved by the browser, and later sent back to the server. A cookie's value can uniquely identify a client, so cookies are commonly used for session management.

A cookie has a name, a single value, and optional attributes such as a comment, path and domain qualifiers, a maximum age, and a version number. Some Web browsers have bugs in how they handle the optional attributes, so use them sparingly to improve the interoperability of your servlets.

The servlet sends cookies to the browser by using the `HttpServletResponse.addCookie(jakarta.servlet.http.Cookie)` method, which adds fields to HTTP response headers to send cookies to the browser, one at a time. The browser is expected to support 50 cookies for each domain, 3000 cookies total, and may limit cookie size to 4 KiB each.

The browser returns cookies to the servlet by adding fields to HTTP request headers. Cookies can be retrieved from a request by using the `HttpServletRequest.getCookies()` method. Several cookies might have the same name but different path attributes.

Cookies affect the caching of the Web pages that use them. HTTP 1.0 does not cache pages that use cookies created with this class. This class does not support the cache control defined with HTTP 1.1.

This class supports both the RFC 6265 specification.

See Also:
  - Serialized Form

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Cookie(String name, String value)`
  Constructs a cookie with a specified name and value.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Object`
  `clone()`
  Overrides the standard `java.lang.Object.clone` method to return a copy of this cookie.
  `boolean`
  `equals(Object obj)`
  `String`
  `getAttribute(String name)`
  Obtain the value for a given attribute.
  `Map<String,String>`
  `getAttributes()`
  Obtain the Map of attributes and values (excluding version) for this cookie.
  `String`
  `getComment()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  This is no longer required with RFC 6265
  `String`
  `getDomain()`
  Returns the domain name set for this cookie.
  `int`
  `getMaxAge()`
  Returns the maximum age of the cookie, specified in seconds, By default, `-1` indicating the cookie will persist until browser shutdown.
  `String`
  `getName()`
  Returns the name of the cookie.
  `String`
  `getPath()`
  Returns the path on the server to which the browser returns this cookie.
  `boolean`
  `getSecure()`
  Returns `true` if the browser is sending cookies only over a secure protocol, or `false` if the browser can send cookies using any protocol.
  `String`
  `getValue()`
  Returns the value of the cookie.
  `int`
  `getVersion()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  This is no longer required with RFC 6265
  `int`
  `hashCode()`
  `boolean`
  `isHttpOnly()`
  Gets the flag that controls if this cookie will be hidden from scripts on the client side.
  `void`
  `setAttribute(String name, String value)`
  Sets the value for the given cookie attribute.
  `void`
  `setComment(String purpose)`
  Deprecated, for removal: This API element is subject to removal in a future version.
  This is no longer required with RFC 6265
  `void`
  `setDomain(String pattern)`
  Specifies the domain within which this cookie should be presented.
  `void`
  `setHttpOnly(boolean httpOnly)`
  Sets the flag that controls if this cookie will be hidden from scripts on the client side.
  `void`
  `setMaxAge(int expiry)`
  Sets the maximum age of the cookie in seconds.
  `void`
  `setPath(String uri)`
  Specifies a path for the cookie to which the client should return the cookie.
  `void`
  `setSecure(boolean flag)`
  Indicates to the browser whether the cookie should only be sent using a secure protocol, such as HTTPS or SSL.
  `void`
  `setValue(String newValue)`
  Assigns a new value to a cookie after the cookie is created.
  `void`
  `setVersion(int v)`
  Deprecated, for removal: This API element is subject to removal in a future version.
  This is no longer required with RFC 6265

  ### Methods inherited from class java.lang.Object

  `finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### Cookie

    public Cookie(String name, String value)
    Constructs a cookie with a specified name and value.

    The cookie's name cannot be changed after creation.

    The value can be anything the server chooses to send. Its value is probably of interest only to the server. The cookie's value can be changed after creation with the `setValue` method.

    Parameters:
      `name` - a `String` specifying the name of the cookie
      `value` - a `String` specifying the value of the cookie
    Throws:
      `IllegalArgumentException` - if the cookie name contains illegal characters
    See Also:
      - `setValue(java.lang.String)`

- ## Method Details

  - ### setComment

    @Deprecated(since="Servlet 6.0", forRemoval=true) public void setComment(String purpose)
    Deprecated, for removal: This API element is subject to removal in a future version.
    This is no longer required with RFC 6265
    If called, this method has no effect.
    Parameters:
      `purpose` - ignored
    See Also:
      - `getComment()`

  - ### getComment

    @Deprecated(since="Servlet 6.0", forRemoval=true) public String getComment()
    Deprecated, for removal: This API element is subject to removal in a future version.
    This is no longer required with RFC 6265
    With the adoption of support for RFC 6265, this method should no longer be used.
    Returns:
      always `null`
    See Also:
      - `setComment(java.lang.String)`

  - ### setDomain

    public void setDomain(String pattern)
    Specifies the domain within which this cookie should be presented.

    By default, cookies are only returned to the server that sent them.

    Parameters:
      `pattern` - a `String` containing the domain name within which this cookie is visible
    See Also:
      - `getDomain()`

  - ### getDomain

    public String getDomain()
    Returns the domain name set for this cookie.
    Returns:
      a `String` containing the domain name
    See Also:
      - `setDomain(java.lang.String)`

  - ### setMaxAge

    public void setMaxAge(int expiry)
    Sets the maximum age of the cookie in seconds.

    A positive value indicates that the cookie will expire after that many seconds have passed. Note that the value is the maximum age when the cookie will expire, not the cookie's current age.

    A negative value means that the cookie is not stored persistently and will be deleted when the Web browser exits. A zero value causes the cookie to be deleted.

    Parameters:
      `expiry` - an integer specifying the maximum age of the cookie in seconds; if negative, means the cookie is not stored; if zero, deletes the cookie
    See Also:
      - `getMaxAge()`

  - ### getMaxAge

    public int getMaxAge()
    Returns the maximum age of the cookie, specified in seconds, By default, `-1` indicating the cookie will persist until browser shutdown.
    Returns:
      an integer specifying the maximum age of the cookie in seconds; if negative, means the cookie persists until browser shutdown
    See Also:
      - `setMaxAge(int)`

  - ### setPath

    public void setPath(String uri)
    Specifies a path for the cookie to which the client should return the cookie.

    The cookie is visible to all the pages in the directory you specify, and all the pages in that directory's subdirectories. A cookie's path must include the servlet that set the cookie, for example, /catalog, which makes the cookie visible to all directories on the server under /catalog.

    Parameters:
      `uri` - a `String` specifying a path
    See Also:
      - `getPath()`

  - ### getPath

    public String getPath()
    Returns the path on the server to which the browser returns this cookie. The cookie is visible to all subpaths on the server.
    Returns:
      a `String` specifying a path that contains a servlet name, for example, /catalog
    See Also:
      - `setPath(java.lang.String)`

  - ### setSecure

    public void setSecure(boolean flag)
    Indicates to the browser whether the cookie should only be sent using a secure protocol, such as HTTPS or SSL.

    The default value is `false`.

    Parameters:
      `flag` - if `true`, sends the cookie from the browser to the server only when using a secure protocol; if `false`, sent on any protocol
    See Also:
      - `getSecure()`

  - ### getSecure

    public boolean getSecure()
    Returns `true` if the browser is sending cookies only over a secure protocol, or `false` if the browser can send cookies using any protocol.
    Returns:
      `true` if the browser uses a secure protocol; otherwise, `false`
    See Also:
      - `setSecure(boolean)`

  - ### getName

    public String getName()
    Returns the name of the cookie. The name cannot be changed after creation.
    Returns:
      a `String` specifying the cookie's name

  - ### setValue

    public void setValue(String newValue)
    Assigns a new value to a cookie after the cookie is created. If you use a binary value, you may want to use BASE64 encoding.

    With Version 0 cookies, values should not contain white space, brackets, parentheses, equals signs, commas, double quotes, slashes, question marks, at signs, colons, and semicolons. Empty values may not behave the same way on all browsers.

    Parameters:
      `newValue` - a `String` specifying the new value
    See Also:
      - `getValue()`
      - `Cookie`

  - ### getValue

    public String getValue()
    Returns the value of the cookie.
    Returns:
      a `String` containing the cookie's present value
    See Also:
      - `setValue(java.lang.String)`
      - `Cookie`

  - ### getVersion

    @Deprecated(since="Servlet 6.0", forRemoval=true) public int getVersion()
    Deprecated, for removal: This API element is subject to removal in a future version.
    This is no longer required with RFC 6265
    With the adoption of support for RFC 6265, this method should no longer be used.
    Returns:
      Always zero
    See Also:
      - `setVersion(int)`

  - ### setVersion

    @Deprecated(since="Servlet 6.0", forRemoval=true) public void setVersion(int v)
    Deprecated, for removal: This API element is subject to removal in a future version.
    This is no longer required with RFC 6265
    If called, this method has no effect.
    Parameters:
      `v` - Ignored
    See Also:
      - `getVersion()`

  - ### clone

    public Object clone()
    Overrides the standard `java.lang.Object.clone` method to return a copy of this cookie.
    Overrides:
      `clone` in class `Object`

  - ### setHttpOnly

    public void setHttpOnly(boolean httpOnly)
    Sets the flag that controls if this cookie will be hidden from scripts on the client side.
    Parameters:
      `httpOnly` - The new value of the flag
    Since:
      Servlet 3.0

  - ### isHttpOnly

    public boolean isHttpOnly()
    Gets the flag that controls if this cookie will be hidden from scripts on the client side.
    Returns:
      `true` if the cookie is hidden from scripts, else `false`
    Since:
      Servlet 3.0

  - ### setAttribute

    public void setAttribute(String name, String value)
    Sets the value for the given cookie attribute. When a value is set via this method, the value returned by the attribute specific getter (if any) must be consistent with the value set via this method.
    Parameters:
      `name` - Name of attribute to set
      `value` - Value of attribute
    Throws:
      `IllegalArgumentException` - If the attribute name is null or contains any characters not permitted for use in Cookie names.
      `NumberFormatException` - If the attribute is known to be numerical but the provided value cannot be parsed to a number.
    Since:
      Servlet 6.0

  - ### getAttribute

    public String getAttribute(String name)
    Obtain the value for a given attribute. Values returned from this method must be consistent with the values set and returned by the attribute specific getters and setters in this class.
    Parameters:
      `name` - Name of attribute to return
    Returns:
      Value of specified attribute
    Since:
      Servlet 6.0

  - ### getAttributes

    public Map<String,String> getAttributes()
    Obtain the Map of attributes and values (excluding version) for this cookie.
    Returns:
      A read-only Map of attributes to values, excluding version.
    Since:
      Servlet 6.0

  - ### hashCode

    public int hashCode()
    Overrides:
      `hashCode` in class `Object`

  - ### equals

    public boolean equals(Object obj)
    Overrides:
      `equals` in class `Object`